// DialogWidget.cpp //

#include "DialogWidget.h"
#include <string>
#include <iostream>

#include "UI.h"

using std::cerr;
using std::endl;
using std::string;

DialogWidget :: DialogWidget (int iYSize, int iXSize, int iYPos, int iXPos
        , const string& rkoStrMsg)
  : Widget(iYSize, iXSize, iYPos, iXPos, true)
{
  /*c_kiYSize = iYSize;
  c_kiXSize = iXSize;
  c_kiYPos = iYPos;
  c_kiXPos = iXPos;*/
  keypad(m_poWin, true);
  m_oStrMsg = rkoStrMsg;
}

int DialogWidget :: KeyFocus (void)
{
  curs_set(0);
  int iCh = GetCh(m_iYSize/2, m_iXSize/2);
  switch (iCh)
  {
    case 9:
      UI::Instance()->Status("");
      break;
        
    case 10:
      return iCh;
      break;
  }
  return iCh;
}

void DialogWidget :: Draw (void)
{
  DrawDialog();
}

void DialogWidget :: DrawDialog (void)
{
  string oStrTemp = m_oStrMsg;
  int iYPos = 0;
  wattron(m_poWin,WA_BOLD);
  while(oStrTemp.size())
  {
    int iPos = oStrTemp.find('\n');
    if(iPos == -1)
    {
      break;
    }
    //cerr << "{" << iPos << "}" << endl;
    string oStrMsg = oStrTemp.substr(0,iPos);
    oStrTemp = oStrTemp.substr(iPos+1,(oStrTemp.size()-(iPos+1)));
    //cerr << "[" << m_oStrMsg << "]" << endl;
    //cerr << "(" <<oStrTemp << ")" << endl;
    AddStr(iYPos,0,oStrMsg);
    iYPos++;
  }
  AddStr(iYPos,0,oStrTemp);
  wattroff(m_poWin,WA_BOLD);
}

// DialogWidget.cpp //
