// DieWidget.cpp //

#include "DieWidget.h"
#include <sstream>
#include <string>

#include "UI.h"

using std::stringstream;

DieWidget :: DieWidget (Die *poDie)
  : Widget(c_kiYSize+3, c_kiXSize+4, c_kiYPos, c_kiXPos, true), 
   m_poDie(NULL)
{
    m_poDie = poDie;
    keypad(m_poWin, true);
}

void DieWidget :: Draw (void)
{
/*  string oStrText = "#";
  AddStr(c_kiYSize/2, c_kiXSize/2+1, oStrText);*/
  DrawDie();
}

int DieWidget :: KeyFocus (void)
{
  curs_set(0);
  int iCh = GetCh(c_kiYSize/2, c_kiXSize/2);
  switch (iCh)
  {
    case 9:
      UI::Instance()->Status("");
      break;
        
    case 10:
      {
        Roll();
        m_poDie->Roll();
        Render();
      }
      break;
  }
  return iCh;
}

void DieWidget :: DrawDie (void)
{
  string oStrDieVal;
  stringstream oSrmDieVal;
  oSrmDieVal << m_poDie->GetFaceVal();
  oStrDieVal += oSrmDieVal.str();
  int iAttri = COLOR_PAIR(COLORPAIR_5)|WA_BOLD;
  wattron(m_poWin,iAttri);
  AddStr(c_kiYSize/2, c_kiXSize/2+1,oStrDieVal);
  wattroff(m_poWin,iAttri);

}

void DieWidget :: Roll (void)
{
  char pcChars[] = {'|', '/', '-', "\\"[0]};
  string oStrText;
  for(int i=0; i<12; i++)
  {
    oStrText = pcChars[i%4];
    napms(100);
    erase();
    wattron(m_poWin,WA_BOLD);
    AddStr(c_kiYSize/2, c_kiXSize/2+1, oStrText);
    wattroff(m_poWin,WA_BOLD);
    Refresh();
  }
}

Die& DieWidget :: GetDie(void)
{
  return *m_poDie;
}

// DieWidget.cpp //
