// DieWidget.h //

#ifndef __DIEWIDGET_H
#define __DIEWIDGET_H

#include "Widget.h"
#include "Die.h"

/** This widget displays die facevalue **/

class DieWidget : public Widget
{
  public:
    /// constructor takes the Die object
    DieWidget (Die *poDie);

    /// Die window y dimension
    static const int c_kiYSize = 4;

    /// Die window x dimension
    static const int c_kiXSize = 5;

    /// Die window y position
    static const int c_kiYPos = 14;

    /// Die window x position
    static const int c_kiXPos = 61;

    /// application logic of the particular type of widget
    virtual void Draw (void);
    
    /// this window gets the keyboard focus
    virtual int KeyFocus (void);

  protected:
    /// display the current state of the die 
    virtual void DrawDie (void);

    /// display the die rolling view
    virtual void Roll (void);

    /// Get a reference to the die
    Die& GetDie (void);

  private:
    /// the die widget
    Die *m_poDie;
};

#endif //__DIEWIDGET_H

// DieWidget.h //
