// ui_ex.h //

#ifndef __UI_EX_H
#define __UI_EX_H

#include <stdexcept>

using std::runtime_error;

/** the UI instance exists but it was attempted to be instantiated again*/
class UIInstantiated : public runtime_error
{
 public:
    UIInstantiated (void) : runtime_error ("The UI already exists")
    {
    }
};

/** the UI instance was accessed before it was instantiated */
class UINotInstantiated : public runtime_error
{
 public:
    UINotInstantiated (void) : runtime_error ("The UI already exists")
    {
    }
};

/** failed to create a new WINDOW using newwin() curses call */
class FailedNewWin : public runtime_error
{
 public:
    FailedNewWin (void) : runtime_error ("Failed to create a new window")
    {
    }
};

#endif//__UI_EX_H
 
// ui_ex.h //
